<?php
/*
Plugin Name: Are PayPal
Plugin URI: http://arepaypal.ehibou.com/
Description: This plugin is used to monetize wordpress blog content using PayPal.
Version: 1.2.4
Author: Aurimas Norkevicius
Author URI: http://are.ehibou.com
*/
/*  Copyright 2007  Aurimas Norkevicius  (email : Aurimas.Norkevicius@gmail.com)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
any later version. Provide the author with your changes to the code.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
if (!class_exists('Are_PayPal')) {
	class Are_PayPal{


		var $prefix = "Are_PayPal";
		var $paied_users_table;
		var $paied_items_table;
		var $bonus_posts_table;
		var $paypal_payment_info_table;
		var $paypal_url;
		var $paypal_email;

		function Are_PayPal(){
			global $wpdb;
			//Initialize properties
			$this->paied_users_table = $wpdb->prefix . $this->prefix . "_users";
			$this->paied_items_table = $wpdb->prefix . $this->prefix . "_items";
			$this->bonus_posts_table = $wpdb->prefix . $this->prefix . "_bonus";
			$this->paypal_payment_info_table=$wpdb->prefix . $this->prefix . "_payment_info";
			$this->paypal_url="https://www.paypal.com/cgi-bin/webscr";
			if (get_option($this->prefix.'_test')=='checked'){
				$this->paypal_url = "https://www.sandbox.paypal.com/cgi-bin/webscr";
			}
			$this->paypal_email = get_option($this->prefix.'_PayPal_Email');

			//Hook into wordpress
			add_action('admin_menu', array(&$this,'Are_PayPal_Configuration'));
			add_filter('the_content', array(&$this,'post_filter'));
			add_action('wp_head', array(&$this,'add_meta_tags_for_robots'));
			register_activation_hook(__FILE__,array(&$this,'install'));
		}

		function post_filter($content){
			$start_delimiter="[".$this->prefix."_LoginPlease]";
			$end_delimiter="[/".$this->prefix."_LoginPlease]";
			global $current_user, $user_ID,$post_ID,$post,$id;
			$postID=$post_ID;
			$userID=$user_ID;
			if ($userID == 0) {$userID = $current_user->id;}
			if ($postID == 0) {$postID = $post->id;}
			if ($postID == 0) {$postID = $id;}
			if ((!$this->IsGooglebot())&&(($userID == 0) || (!$this->IsPostPurchased($postID,$userID)))){
				$start = strpos($content, $start_delimiter);
				$end = strpos($content, $end_delimiter);

				$pre = substr($content,0,$start);
				$suf = substr($content,$end,strlen($content));
				if (!(($start===FALSE) && ($end===FALSE))){
					if ($userID == 0){
						$domain = $_SERVER['HTTP_HOST'];
						$url = "http://" . $domain . $_SERVER['REQUEST_URI'];

						$LoginButton="<a class='LoginButton' href='".get_option ('siteurl')."/wp-login.php?redirect_to=$url'>".__("Login")."</a>";

						$content= $pre."<div class='".$this->prefix."_UserIsNotLoggedIn'>".get_option($this->prefix.'_TextToShowIfNotLogedIn')."</div>".$LoginButton.$suf;
					}else{
						global $wpdb;
						$items = $wpdb->get_results("SELECT posts.ID,posts.post_title, items.* FROM $wpdb->posts posts INNER JOIN $this->paied_items_table items ON items.post_id=posts.id WHERE posts.id='$postID'");
						if($items) {
							$item=$items[0];
							$item_id=$item->ID;
							$item_title=$item->post_title;
							$item_amount=$item->amount;
							$item_currency=$item->currency;
							$item_name=$item->name;
							$item_number=$item->number;
							$postButton=$this->paypal_buy_now_form($item_name.":".$item_title,$item_number,$item_amount,$item_currency,$postID,$userID);
						}
						$blog_item_name=get_option($this->prefix.'_BlogName');
						if ($blog_item_name){
							$blog_item_amount=get_option($this->prefix.'_BlogAmount');
							$blog_item_currency=get_option($this->prefix.'_BlogCurrency');
							$blog_item_name=get_option($this->prefix.'_BlogName');
							$blog_item_number=get_option($this->prefix.'_BlogNumber');
							$blog_item_expire=get_option($this->prefix.'_BlogExpire');
							$blogButton=$this->paypal_buy_now_form($blog_item_name.":".$blog_item_title,$blog_item_number,$blog_item_amount,$blog_item_currency,-1,$userID);//-1 post id for whole site
						}
						if ($blogButton || $postButton){
							$textExplanation ="<p style='text-align:center;'>".get_option($this->prefix.'_TextToShowIfNotPurchased')."</p>";
							$content = preg_replace("/\\[Are_PayPal_LoginPlease\\].*?\\[\/Are_PayPal_LoginPlease\\]/i",$textExplanation.$postButton.$blogButton,$content);
						}

					}
				}
			}
			$content= str_replace($start_delimiter,'',$content);
			$content= str_replace($end_delimiter,'',$content);
			return $content;
		}
		function Are_PayPal_Configuration() {
			global $wpdb;
			if ( function_exists('add_submenu_page') ){
				add_menu_page(__($this->prefix), __($this->prefix), 10, __FILE__, array(&$this,'Main_Configuration_Page'));
				add_submenu_page(__FILE__, __($this->prefix.' Configuration 2'), __('Post Prices'), 10,$this->prefix.'_PostSetup' , array(&$this,'Configure_Prices_For_Posts'));
				add_submenu_page(__FILE__, __($this->prefix.' Configuration 3'), __('Paypal data'), 10,$this->prefix.'_PaypalData' , array(&$this,'View_Payments'));
				add_submenu_page(__FILE__, __($this->prefix.' Configuration 4'), __('Blog Price'), 10,$this->prefix.'_BlogPrice' , array(&$this,'Blog_Price'));
			}
		}

		function install(){
			global $wpdb;

			if($wpdb->get_var("SHOW TABLES LIKE '$this->paied_items_table'") != $this->paied_items_table) {
				$sql = "CREATE TABLE " . $this->paied_items_table . " (
		`id` bigint(20) NOT NULL auto_increment,
		`post_id` bigint(20) NOT NULL,
		`name` varchar(255) NOT NULL,
		`number` varchar(255) default NULL,
		`amount` double NOT NULL,
		`currency` char(3) NOT NULL,
		UNIQUE KEY `id` (`id`)
		);";
				$sql = $sql . "CREATE TABLE " . $this->paied_users_table . " (
		`id` bigint(20) NOT NULL auto_increment,
		`post_id` bigint(20) NOT NULL,
		`user_id` bigint(20) NOT NULL,
		UNIQUE KEY `id` (`id`)
		);";
				$sql=$sql."
		CREATE TABLE ".$this->paypal_payment_info_table." (
		  `FIRSTNAME`     VARCHAR(100)   NOT NULL   DEFAULT '',
		  `LASTNAME`      VARCHAR(100)   NOT NULL   DEFAULT '',
		  `BUYER_EMAIL`   VARCHAR(100)   NOT NULL   DEFAULT '',
		  `STREET`        VARCHAR(100)   NOT NULL   DEFAULT '',
		  `CITY`          VARCHAR(50)   NOT NULL   DEFAULT '',
		  `STATE`         CHAR(3)   NOT NULL   DEFAULT '',
		  `ZIPCODE`       VARCHAR(11)   NOT NULL   DEFAULT '',
		  `MEMO`          VARCHAR(255)   DEFAULT NULL,
		  `ITEMNAME`      VARCHAR(255)   DEFAULT NULL,
		  `ITEMNUMBER`    VARCHAR(50)   DEFAULT NULL,
		  `OS0`           VARCHAR(20)   DEFAULT NULL,
		  `ON0`           VARCHAR(50)   DEFAULT NULL,
		  `OS1`           VARCHAR(20)   DEFAULT NULL,
		  `ON1`           VARCHAR(50)   DEFAULT NULL,
		  `QUANTITY`      CHAR(3)   DEFAULT NULL,
		  `PAYMENTDATE`   VARCHAR(50)   NOT NULL   DEFAULT '',
		  `PAYMENTTYPE`   VARCHAR(10)   NOT NULL   DEFAULT '',
		  `TXNID`         VARCHAR(30)   NOT NULL   DEFAULT '',
		  `MC_GROSS`      VARCHAR(6)   NOT NULL   DEFAULT '',
		  `MC_FEE`        VARCHAR(5)   NOT NULL   DEFAULT '',
		  `PAYMENTSTATUS` VARCHAR(15)   NOT NULL   DEFAULT '',
		  `PENDINGREASON` VARCHAR(10)   DEFAULT NULL,
		  `TXNTYPE`       VARCHAR(10)   NOT NULL   DEFAULT '',
		  `TAX`           VARCHAR(10)   DEFAULT NULL,
		  `MC_CURRENCY`   VARCHAR(5)   NOT NULL   DEFAULT '',
		  `REASONCODE`    VARCHAR(20)   NOT NULL   DEFAULT '',
		  `CUSTOM`        VARCHAR(255)   NOT NULL   DEFAULT '',
		  `COUNTRY`       VARCHAR(20)   NOT NULL   DEFAULT '',
		  `DATECREATION`  DATE   NOT NULL   DEFAULT '0000-00-00');";
				require_once(ABSPATH . 'wp-admin/upgrade-functions.php');
				dbDelta($sql);
				add_option($this->prefix."_db_version", "1.0");
			}
			$version = get_option($this->prefix."_db_version");
			if ($version=="1.0"){
				$sql = "CREATE TABLE " . $this->paied_items_table . " (
		`id` bigint(20) NOT NULL auto_increment,
		`post_id` bigint(20) NOT NULL,
		`name` varchar(255) NOT NULL,
		`number` varchar(255) default NULL,
		`amount` double NOT NULL,
		`currency` char(3) NOT NULL,
		`expire` bigint(20) NULL,
		UNIQUE KEY `id` (`id`)
		);";
				$sql = $sql . "CREATE TABLE " . $this->paied_users_table . " (
		`id` bigint(20) NOT NULL auto_increment,
		`post_id` bigint(20) NOT NULL,
		`user_id` bigint(20) NOT NULL,
		`expire` bigint(20) NULL,
		`purchase_date` timestamp NOT NULL,
		UNIQUE KEY `id` (`id`)
		);";

				$sql = $sql . "
					CREATE TABLE $this->bonus_posts_table (
  					`post1_id` bigint(20) NOT NULL,
  					`post2_id` bigint(20) NOT NULL,
  					PRIMARY KEY  (`post1_id`,`post2_id`)
					);
				";
				require_once(ABSPATH . 'wp-admin/upgrade-functions.php');
				dbDelta($sql);

				$wpdb->query($sql);
				update_option($this->prefix."_db_version", "2.0");

			}
		}


		function Main_Configuration_Page() {
			if ( isset($_POST['submit']) ) {
				check_admin_referer();

				$Value = $_POST['TextToShowIfNotLogedIn'];
				update_option($this->prefix.'_TextToShowIfNotLogedIn', $Value);

				$Value = $_POST['PayPal_Email'];
				update_option($this->prefix.'_PayPal_Email', $Value);

				$Value = $_POST['test'];
				update_option($this->prefix.'_test', $Value);

				$Value = $_POST['TextToShowIfNotPurchased'];
				update_option($this->prefix.'_TextToShowIfNotPurchased', $Value);
				$LastAction = __("Updated successfully ...");
			}
			?>
			<?php if(!empty($LastAction)) { echo '<!-- Last Action --><div id="message" class="updated fade"><p>'.$LastAction.'</p></div>'; } ?>
			<div class="wrap">
				<h2><?php _e($this->prefix.' Configuration'); ?></h2>
				<p><?php printf(__('<a href="http://are.ehibou.com/">Aurimas Norkevicius</a> for help with the plugin.')); ?></p>
				<form action="" method="post" id="<?=$this->prefix?>-conf" style="margin: auto; width: 25em; ">
					<h3><label for="TextToShowIfNotLogedIn"><?php _e('Text to show if visitor is not logged in'); ?></label></h3>
					<p><textarea id="TextToShowIfNotLogedIn" name="TextToShowIfNotLogedIn" type="text" size="12" style="font-family: 'Courier New', Courier, mono; font-size: 1.5em;"><?php echo stripslashes(get_option($this->prefix.'_TextToShowIfNotLogedIn')); ?></textarea> 
					<p><textarea id="TextToShowIfNotPurchased" name="TextToShowIfNotPurchased" type="text" size="12" style="font-family: 'Courier New', Courier, mono; font-size: 1.5em;"><?php echo stripslashes(get_option($this->prefix.'_TextToShowIfNotPurchased')); ?></textarea> 
					<p><input id="test" name="test" type="checkbox" value="checked" <?php echo get_option($this->prefix.'_test'); ?> />&nbsp;&nbsp;<label for="test"><?php _e('<a href="http://developer.paypal.com" target=_blank>Use PayPal Sandbox</a> (testing only)'); ?></label></p>
					
					<h3><label for="PayPal_Email"><?php _e('PayPal email'); ?></label></h3>
					<p><input id="PayPal_Email" name="PayPal_Email" type="text" size="12" style="font-family: 'Courier New', Courier, mono; font-size: 1.5em;" value="<?=stripslashes(get_option($this->prefix.'_PayPal_Email')); ?>"/></p>

					<p class="submit"><input type="submit" name="submit" value="<?php _e('Update Options&raquo;'); ?>" /></p>
				</form>
			</div>
			<?php
		}
		function Blog_Price() {
			if ( isset($_POST['submit']) ) {
				check_admin_referer();

				$Value=$_POST["amount"];
				update_option($this->prefix.'_BlogAmount', $Value);
				$Value=$_POST["currency"];
				update_option($this->prefix.'_BlogCurrency', $Value);
				$Value=$_POST["name"];
				update_option($this->prefix.'_BlogName', $Value);
				$Value=$_POST["number"];
				update_option($this->prefix.'_BlogNumber', $Value);
				$Value=$_POST["expire"];
				update_option($this->prefix.'_BlogExpire', $Value);
				$LastAction = __(" Updated successfully ...");
			}
			if ( isset($_POST['clear']) ) {
				check_admin_referer();

				delete_option($this->prefix.'_BlogAmount');
				delete_option($this->prefix.'_BlogCurrency');
				delete_option($this->prefix.'_BlogName');
				delete_option($this->prefix.'_BlogNumber');
				delete_option($this->prefix.'_BlogExpire');
				$LastAction = __(" Deleted successfully ...");
				
			}

			$item_amount=get_option($this->prefix.'_BlogAmount');
			$item_currency=get_option($this->prefix.'_BlogCurrency');
			$item_name=get_option($this->prefix.'_BlogName');
			$item_number=get_option($this->prefix.'_BlogNumber');
			$item_expire=get_option($this->prefix.'_BlogExpire');
			?>
			<?php if(!empty($LastAction)) { echo '<!-- Last Action --><div id="message" class="updated fade"><p>'.$LastAction.'</p></div>'; } ?>
			<div class="wrap">
				<h2><?php _e('Edit Blog Price'); ?></h2>
				<form method="post" action="" style="margin: auto; width: 25em; ">
				<input type="hidden" name="page" value="<?=$_GET["page"]?>"/>
				<table width="100%"  border="0" cellspacing="3" cellpadding="3">
					<tr>
						<td width="28%" style="background-color: #eee"><?php _e('Name'); ?></td>
						<td><input type="text" name="name" value="<?=$item_name?>"/></td>
					</tr>
					<tr>
						<td width="28%" style="background-color: #eee"><?php _e('Number'); ?></td>
						<td><input type="text" name="number" value="<?=$item_number?>"/></td>
					</tr>
					<tr>
						<td width="28%" style="background-color: #eee"><?php _e('Price'); ?></td>
						<td><input type="text" name="amount" value="<?=$item_amount?>"/></td>
					</tr>
					<tr>
						<td width="28%" style="background-color: #eee"><?php _e('Currency'); ?></td>
						<td><input type="text" name="currency" value="<?=$item_currency?>"/></td>
					</tr>
					<tr>
						<td width="28%" style="background-color: #eee"><?php _e('Expire (period in days)'); ?></td>
						<td><input type="text" name="expire" value="<?=$item_expire?>"/></td>
					</tr>
				</table>
				<p class="submit"><input type="submit" name="submit" value="Submit&raquo;"/></p>
				<p class="submit"><input type="submit" name="clear" value="Delete&raquo;"/></p>
				</form>
			</div>
			<?php
		}

		function View_Payments() {
			global $wpdb;
			$payments=$wpdb->get_results("select * from $this->paypal_payment_info_table",ARRAY_A);
			if(count($payments) > 0) {
				$firstRow=$payments[0];
				$columnNames=array_keys($firstRow);
				?>
			<div class="wrap">
<!-- Manage Post Prices -->
	<h2><?php _e('View Payments'); ?></h2>
	<table width="100%"  border="0" cellspacing="3" cellpadding="3">
	<?php
	?>
	<?
	foreach($payments as $row) {
		?>
		<tr><td>
		<table width="100%"  border="0" cellspacing="3" cellpadding="3" style="border-width:1px;border-color:black;">
		<?
		$this->Arrange_dataInto_Lines($columnNames,$row,4);
		?>
		</table>
		</td></tr>
		<?
	}
	?>
	</table>
	</div>
	<?
			}
		}
		function Arrange_dataInto_Lines($columnNames,$row,$number_of_rows,$current_row=0){
			if ($number_of_rows>$current_row){
					?>
					<tr>
					<?
					$counter=0;
					foreach($columnNames as $columnName) {
						$counter++;
						if ($counter % $number_of_rows==$current_row){
							?><th><? _e($columnName)?></td><?
						}
					}
					?>
					</tr>
					<tr>
					<?
					$counter=0;
					foreach($columnNames as $columnName) {
						$counter++;
						if ($counter % $number_of_rows==$current_row){
							?><td><?=$row[$columnName]?></td><?
						}
					}
					?>
					</tr>
					<?			
					$this->Arrange_dataInto_Lines($columnNames,$row,$number_of_rows,$current_row+1);
			}
		}
		function Configure_Prices_For_Posts() {
			global $wpdb;
			### Get The Posts
			$action = mysql_escape_string($_GET["action"]);
			$post_id = mysql_escape_string($_GET["post_id"]);
			if ($_GET["BonusSubmit"]){
				if ($_GET["BonusSubmit"]==">>"){
					$post2_id=$_GET["post_to_package"];
					$wpdb->query("INSERT INTO $this->bonus_posts_table VALUES($post_id,$post2_id)");
					$wpdb->query("INSERT INTO $this->bonus_posts_table VALUES($post2_id,$post_id)");
					$LastAction = __("Added successfully ...");
				}else{
					$post2_id=$_GET["post_in_package"];
					$wpdb->query("DELETE FROM $this->bonus_posts_table WHERE post1_id=$post_id AND post2_id=$post2_id");
					$wpdb->query("DELETE FROM $this->bonus_posts_table WHERE post1_id=$post2_id AND post2_id=$post_id");
					$LastAction = __("Removed successfully ...");
				}
			}
			if (($action=="delete")&&($post_id)){
				$wpdb->query("DELETE FROM $this->paied_items_table WHERE post_id=$post_id");
				$LastAction = __("Deleted successfully ...");
			}
			if (($action=="write")&&($post_id)){
				$items = $wpdb->get_results("SELECT posts.ID,posts.post_title, items.* FROM $wpdb->posts posts LEFT OUTER JOIN $this->paied_items_table items ON items.post_id=posts.id WHERE posts.id='$post_id'");
				$item=$items[0];
				$item_id=$item->ID;
				$item_amount=mysql_escape_string($_GET["amount"]);
				$item_currency=mysql_escape_string($_GET["currency"]);
				$item_name=mysql_escape_string($_GET["name"]);
				$item_number=mysql_escape_string($_GET["number"]);
				$item_purchasers=$_GET["purchasers"];
				$item_expire=$_GET["expire"];
				if ($item->post_id){
					//UPDATE
					$sql="UPDATE $this->paied_items_table SET name='$item_name',number='$item_number',amount='$item_amount',currency='$item_currency',expire='$item_expire' WHERE post_id=$item_id";
					$LastAction = __("Updated successfully ...");
				}else{
					//INSERT
					$sql="INSERT INTO $this->paied_items_table (name,number,amount,currency, post_id,expire) VALUES('$item_name','$item_number','$item_amount','$item_currency','$item_id','$item_expire')";
					$LastAction = __("Inserted successfully ...");
				}
				$wpdb->query($sql);
				$wpdb->query("DELETE FROM $this->paied_users_table WHERE post_id=$item_id");
				if ($item_purchasers){
					foreach ($item_purchasers as $item_purchaser){
						$item_purchaser=mysql_escape_string($item_purchaser);
						$wpdb->query("INSERT INTO $this->paied_users_table(post_id,user_id) VALUES($item_id,$item_purchaser)");
					}
				}
			}
			if (($action=="bonus")&&($post_id)){
				$items = $wpdb->get_results("SELECT posts.ID,posts.post_title, items.* FROM $wpdb->posts posts LEFT OUTER JOIN $this->paied_items_table items ON items.post_id=posts.id WHERE posts.id='$post_id'");
				if($items) {
					$item=$items[0];
					$item_id=$item->ID;
					$item_title=$item->post_title;
					$item_amount=$item->amount;
					$item_currency=$item->currency;
					$item_expire=$item->expire;
					$item_name=$item->name;
					$item_number=$item->number;
				?>
			<? if(!empty($LastAction)) { echo '<!-- Last Action --><div id="message" class="updated fade"><p>'.$LastAction.'</p></div>'; } ?>
			<div class="wrap">
				<h2><?php _e('Bonus posts'); ?></h2>
				<form method="get" action="" style="margin: auto; width: 25em; ">
				<input type="hidden" name="action" value="bonus"/>
				<input type="hidden" name="page" value="<?=$_GET["page"]?>"/>
				<input type="hidden" name="post_id" value="<?=$item_id?>"/>
						<table>
						<tr><th colspan="3"><strong><?php _e('Post: '); ?><?=$item_title?></strong></th></tr>
						<tr>
							<th><?php _e('Available posts'); ?></th>
							<th>&#160;</th>
							<th><?php _e('Bonus posts'); ?></th>
						</tr>
						<tr>
						<td>
						<select multiple="false" name="post_to_package" size="10" style="width:200px;">
						<?
						$posts_to_package=$wpdb->get_results("SELECT p.* FROM $wpdb->posts p WHERE p.id!=$item_id AND p.id NOT IN(select post2_id from $this->bonus_posts_table)");
						if ($posts_to_package){
							foreach($posts_to_package as $post_to_package) {
								?><option value="<?=$post_to_package->ID;?>"><?=$post_to_package->post_title;?></option><?
							}
						}
						?>
						</select>
						</td>
						<td>
						<p class="submit"><input type="submit" name="BonusSubmit" value=">>"/></p><p class="submit"><input name="BonusSubmit" type="submit" value="<<"/></p>
						</td>
						<td>
						<select multiple="false" name="post_in_package" size="10" style="width:200px;">
						<?
						$posts_in_package=$wpdb->get_results("SELECT p.* FROM $wpdb->posts p WHERE p.id!=$item_id AND p.id IN(select post2_id from $this->bonus_posts_table)");
						if ($posts_in_package){
							foreach($posts_in_package as $post_in_package) {
								?><option value="<?=$post_in_package->ID;?>"><?=$post_in_package->post_title;?></option><?
							}
						}
						?>
						</select>
						</td>
						</tr>
						</table>
						</form>
				<form method="GET" action="" style="margin: auto; width: 25em; ">
				<input type="hidden" name="action" value="list"/>
				<input type="hidden" name="page" value="<?=$_GET["page"]?>"/>
				<p class="submit"><input type="submit" value="Cancel&raquo;"/></p>
				</form>
						<?
				}
			}else if (($action=="edit")&&($post_id)){
				$items = $wpdb->get_results("SELECT posts.ID,posts.post_title, items.* FROM $wpdb->posts posts LEFT OUTER JOIN $this->paied_items_table items ON items.post_id=posts.id WHERE posts.id='$post_id'");
				if($items) {
					$item=$items[0];
					$item_id=$item->ID;
					$item_title=$item->post_title;
					$item_amount=$item->amount;
					$item_currency=$item->currency;
					$item_expire=$item->expire;
					$item_name=$item->name;
					$item_number=$item->number;
				?>
			<? if(!empty($LastAction)) { echo '<!-- Last Action --><div id="message" class="updated fade"><p>'.$LastAction.'</p></div>'; } ?>
			<div class="wrap">
				<h2><?php _e('Edit Post Price'); ?></h2>
				<form method="get" action="" style="margin: auto; width: 25em; ">
				<input type="hidden" name="action" value="write"/>
				<input type="hidden" name="page" value="<?=$_GET["page"]?>"/>
				<input type="hidden" name="post_id" value="<?=$item_id?>"/>
				<table width="100%"  border="0" cellspacing="3" cellpadding="3">
					<tr>
						<td width="28%" style="background-color: #eee"><?php _e('ID'); ?></td>
						<td><?=$item_id?></td>
					</tr>
					<tr>
						<td width="28%" style="background-color: #eee"><?php _e('Post Title'); ?></td>
						<td><?=$item_title?></td>
					</tr>
					<tr>
						<td width="28%" style="background-color: #eee"><?php _e('Name'); ?></td>
						<td><input type="text" name="name" value="<?=$item_name?>"/></td>
					</tr>
					<tr>
						<td width="28%" style="background-color: #eee"><?php _e('Number'); ?></td>
						<td><input type="text" name="number" value="<?=$item_number?>"/></td>
					</tr>
					<tr>
						<td width="28%" style="background-color: #eee"><?php _e('Price'); ?></td>
						<td><input type="text" name="amount" value="<?=$item_amount?>"/></td>
					</tr>
					<tr>
						<td width="28%" style="background-color: #eee"><?php _e('Currency'); ?></td>
						<td><input type="text" name="currency" value="<?=$item_currency?>"/></td>
					</tr>
					<tr>
						<td width="28%" style="background-color: #eee"><?php _e('Expire (period in days)'); ?></td>
						<td><input type="text" name="expire" value="<?=$item_expire?>"/></td>
					</tr>
					<tr>
						<td width="28%" style="background-color: #eee"><?php _e('Purchasers'); ?></td>
						<td>
						<select multiple="true" name="purchasers[]" size="10" style="width:200px;">
						<?

						$users = $wpdb->get_results("SELECT u.id,user_login FROM $wpdb->users u INNER JOIN $this->paied_users_table up ON up.user_id=u.id and up.post_id=$item_id");
						if ($users){
							foreach($users as $user) {
								?><option value="<?=$user->id;?>" selected="true"><?=$user->user_login;?></option><?
							}
						}
						$users = $wpdb->get_results("SELECT u.id,user_login FROM $wpdb->users u WHERE u.id not in (SELECT user_id FROM $this->paied_users_table up WHERE up.post_id=$item_id)");
						if ($users){
							foreach($users as $user) {
								?><option value="<?=$user->id;?>"><?=$user->user_login;?></option><?
							}
						}
						?>
						</select>
						</td>
					</tr>
				</table>
				<p class="submit"><input type="submit" value="Submit&raquo;"/></p>
				</form>
				<form method="GET" action="" style="margin: auto; width: 25em; ">
				<input type="hidden" name="action" value="delete"/>
				<input type="hidden" name="page" value="<?=$_GET["page"]?>"/>
				<input type="hidden" name="post_id" value="<?=$item_id?>"/>
				<p class="submit"><input type="submit" value="Clear Priceing&raquo;"/></p>
				</form>
				<form method="GET" action="" style="margin: auto; width: 25em; ">
				<input type="hidden" name="action" value="list"/>
				<input type="hidden" name="page" value="<?=$_GET["page"]?>"/>
				<p class="submit"><input type="submit" value="Cancel&raquo;"/></p>
				</form>
				<?
				}
			}else{
				$items = $wpdb->get_results("SELECT posts.ID,posts.post_title, items.* FROM $wpdb->posts posts LEFT OUTER JOIN $this->paied_items_table items ON items.post_id=posts.id");
?>
			<? if(!empty($LastAction)) { echo '<!-- Last Action --><div id="message" class="updated fade"><p>'.$LastAction.'</p></div>'; } ?>
			<div class="wrap">
<!-- Manage Post Prices -->
	<h2><?php _e('Post Prices'); ?></h2>
	<table width="100%"  border="0" cellspacing="3" cellpadding="3">
	<tr>
		<th width="2%"><?php _e('ID'); ?></th>
		<th width="28%"><?php _e('Post Title'); ?></th>
		<th width="28%"><?php _e('Purchasers'); ?></th>
		<th width="28%"><?php _e('Name'); ?></th>
		<th width="28%"><?php _e('Number'); ?></th>
		<th width="28%"><?php _e('Price'); ?></th>
		<th width="28%"><?php _e('Currency'); ?></th>
		<th width="28%"><?php _e('Expire (period in days)'); ?></th>
		<th width="28%">&nbsp;</th>
	</tr>
	<?php
	if($items) {
		$i = 0;
		foreach($items as $item) {
			if($i%2 == 0) {
				$style = 'style=\'background-color: #eee\'';
			}  else {
				$style = 'style=\'background-color: none\'';
			}
			$item_id=$item->ID;
			$item_title=$item->post_title;
			$item_amount=$item->amount;
			$item_currency=$item->currency;
			$item_expire=$item->expire;
			$item_name=$item->name;
			$item_number=$item->number;
			echo "<tr $style>\n";
			echo "<td>$item_id</td>\n";
			echo "<td>$item_title</td>\n";
			echo "<td>";
			$users = $wpdb->get_results("SELECT user_login FROM $wpdb->users u INNER JOIN $this->paied_users_table up ON up.user_id=u.id and up.post_id=$item_id");
			foreach($users as $user) {
				echo $user->user_login;
				echo "<br/>";
			}
			echo "</td>\n";
			echo "<td>$item_name</td>\n";
			echo "<td>$item_number</td>\n";
			echo "<td>$item_amount</td>\n";
			echo "<td>$item_currency</td>\n";
			echo "<td>$item_expire</td>\n";
				?>
				<td nowrap>
					<?
					if ($item->post_id){
						?><a href="?page=<?=$this->prefix.'_PostSetup'?>&action=delete&post_id=<?=$item_id?>"><?=_e('Clear Priceing')?></a> | <?
						?><a href="?page=<?=$this->prefix.'_PostSetup'?>&action=bonus&post_id=<?=$item_id?>"><?=_e('Edit bonus posts')?></a> | <?
					}
					?>
					<a href="?page=<?=$this->prefix.'_PostSetup'?>&action=edit&post_id=<?=$item_id?>"><?=_e('Edit')?></a>
				</td>
				<?
				echo '</tr>';
				$i++;
		}
	} else {
		echo '<tr><td colspan="2" align="center"><b>'.__('No Posts Found').'</b></td></tr>';
	}
	?>
	</table>
<?}?>
</div>
<?
		}
		function IsGooglebot(){
			// check if user agent contains googlebt
			if(eregi("Googlebot",$_SERVER['HTTP_USER_AGENT'])){
				$ip = $_SERVER['REMOTE_ADDR'];
				//server name e.g. crawl-66-249-66-1.googlebot.com
				$name = gethostbyaddr($ip);
				//check if name ciontains googlebot
				if(eregi("Googlebot",$name)){
					//list of IP's
					$hosts = gethostbynamel($name);
					foreach($hosts as $host){
						if ($host == $ip){
							return true;
						}
					}
					return false; // Pretender, take some action if needed
				}else{
					return false; // Pretender, take some action if needed
				}
			}else{
				// Not googlebot, take some action if needed
			}
			return false;
		}
		function IsPostPurchased($post_id,$user_id){
			$user_id=mysql_escape_string($user_id);
			$post_id_tmp=$post_id;
			$post_id="-1";
			global $wpdb;
			$users = $wpdb->get_results("SELECT users.* FROM . $this->paied_users_table users WHERE (users.post_id='$post_id') AND users.user_id='$user_id' AND (ADDDATE(purchase_date, expire) > CURDATE() OR expire is null OR expire = 0)");
			if ($users){
				return true;
			}

			$item_amount=get_option($this->prefix.'_BlogAmount');
			if ($item_amount){
				$paypal_response=$wpdb->get_results("SELECT * FROM .$this->paypal_payment_info_table WHERE custom ='$post_id|$user_id' AND mc_gross=$item_amount");
				if ($paypal_response){
					//Grant access(This is needed to prevent misfunction on price change)
					$this->PayForItem($post_id,$user_id);
					$wpdb->query("UPDATE $this->paypal_payment_info_table SET custom='[processed]$post_id|$user_id' WHERE custom ='$post_id|$user_id' AND mc_gross=$item_amount");
					return true;
				}
			}

			$post_id=mysql_escape_string($post_id_tmp);
			$sql = "SELECT items.* FROM $this->paied_items_table items WHERE items.post_id='$post_id'";
			$items = $wpdb->get_results($sql);
			if($items) {
				$users = $wpdb->get_results("SELECT users.* FROM . $this->paied_users_table users WHERE (users.post_id='$post_id') AND users.user_id='$user_id' AND (ADDDATE(purchase_date, expire) > CURDATE() OR expire is null OR expire = 0)");
				if ($users){
					return true;
				}
				$item_amount=$items[0]->amount;
				if ($item_amount){
					
					$paypal_response=$wpdb->get_results("SELECT * FROM .$this->paypal_payment_info_table WHERE custom ='$post_id|$user_id' AND mc_gross=$item_amount");
					if ($paypal_response){
						//Grant access(This is needed to prevent misfunction on price change)
						$this->PayForItem($post_id,$user_id);
						$wpdb->query("UPDATE $this->paypal_payment_info_table SET custom='[processed]$post_id|$user_id' WHERE custom ='$post_id|$user_id' AND mc_gross=$item_amount");
						return true;
					}
				}

			}

			$item_amount=get_option($this->prefix.'_BlogAmount');
			if ($item_amount){
				return false;
			}
		}
		// Create User administration screen
		function PayForItem($post_id,$user_id){
			global $wpdb;
			$post_id=mysql_escape_string($post_id);
			$items = $wpdb->get_results("SELECT * FROM . $this->paied_items_table WHERE post_id='$post_id'");
			$expire='';
			if ($items){
				$expire=$items[0]->expire;
			}
			if ($post_id=="-1"){
				$expire=get_option($this->prefix.'_BlogExpire');
			}
			$user_id=mysql_escape_string($user_id);
			$users = $wpdb->get_results("SELECT users.* FROM . $this->paied_users_table users WHERE users.post_id='$post_id' AND users.user_id='$user_id'");
			if (!$users){
				$wpdb->query("INSERT INTO $this->paied_users_table(post_id,user_id,expire) VALUES('$post_id','$user_id','$expire')");
				$bonuses = $wpdb->get_results("SELECT post2_id FROM . $this->bonus_posts_table WHERE post1_id='$post_id'");
				foreach($bonuses as $bonus) {
					$this->PayForItem($bonus->post2_id,$user_id);
				}
			}
		}
		function paypal_buy_now_form($item_name,$item_number,$item_price,$item_currency,$post_id,$user_id){
			$paypal_url=$this->paypal_url;
			$paypal_email = $this->paypal_email;
			$item_custom = $post_id."|".$user_id;
			$domain = $_SERVER['HTTP_HOST'];
			$item_return = "http://" . $domain . $_SERVER['REQUEST_URI'];
			$result="
		<form action='$paypal_url' method='post'>
		    <center class='are_paypal_contentprice'><strong>$item_price $item_currency</strong><br/><br/></center>
			<input type='hidden' name='cmd' value='_xclick'/>
			<input type='hidden' name='business' value='$paypal_email'/>
			<input type='hidden' name='item_name' value='$item_name'/>
			<input type='hidden' name='item_number' value='$item_number'/>
			<input type='hidden' name='amount' value='$item_price'/>
			<input type='hidden' name='no_shipping' value='1'/>
			<input type='hidden' name='no_note' value='1'/>
			<input type='hidden' name='return' value='$item_return'>
			<input type='hidden' name='custom' value='$item_custom'/>
			<input type='hidden' name='currency_code' value='$item_currency'/>
			<input type='hidden' name='bn' value='IC_ArePayPal'/>
			<input type='image' src='https://www.paypal.com/en_US/i/btn/x-click-butcc.gif' name='submit' alt='Make payments with payPal - it\'s fast, free and secure!'/>
			<img alt='' src='https://www.paypal.com/en_US/i/scr/pixel.gif' width='1' height='1'/>
		</form>
		";
			return $result;
		}
		function add_meta_tags_for_robots(){
			echo('<META NAME="ROBOTS" CONTENT="NOARCHIVE"/>');
		}
	}
}
//instantiate the class
if (class_exists('Are_PayPal')) {
	$Are_PayPal = new Are_PayPal();
}

?>